/******************************************************************************
;  *    @MCU                 : MC51F8124
;  *    @Create Date 		 : 2021.09.01
;  *    @Author/Corporation  : SinoMCU_FAE
;  *    @΢֧QQ    : 2048615934
;  *    @΢ 		 : http://www.sinomcu.com/
;  *    @Copyright 			 : 2021 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                      
******************************************************************************/

#include "ADC_LIB.h"

/************************************************
;  *    @Function Name       : ADC_Init
;  *    @Description         : 
;  *    @IN_Parameter      	 :  ADCx ADò
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Init(ADC_InitTypeDef *ADCx)
{
    ADCCR0 = REG_CLR;
    ADCCR1 = REG_CLR;
    ADRIOS0 = REG_CLR;
    ADRIOS1 = REG_CLR; //Ĵ0

    if (ADCx->ADC_vref == ADC_VREF_EXT_VREF) //ѡⲿοѹ
    {
        ADRIOS1 |= SET_BIT5; //ѡⲿοѹ
        //Vref(P20)Ч,ADCģǿƽVrefѹΪADĲοѹʹ,
        //ʱADCοѹѡλVRS[1:0]ֵ
    }
    ADCCR0 |= (ADCx->ADC_chx | ADCx->ADC_vref);                                     //ͨ/οѹ
    ADCCR1 |= (ADCx->ADC_data_sel | ADCx->ADC_clock_division | ADCx->ADC_sam_time); //ݸʽ/ADʱ/ʱ
    ADRIOS0 |= ADCx->ADC_IOx & 0x00ff;
    ADRIOS1 |= ADCx->ADC_IOx >> 8;     //IO
    if (ADCx->ADC_interrupt == ENABLE) //ʹADCж
    {
        IP &= ~ADC_INT_PRI_ADDR;
        IPH &= ~ADC_INT_PRI_ADDR;    //жȼ
        ADCIE = ADCx->ADC_interrupt; //ADCж
        if (ADCx->ADC_interrupt_priority == HI)
        {
            IP |= ADC_INT_PRI_ADDR; //жȼ
        }
    }
    else
    {
        ADCIE = ADCx->ADC_interrupt; //ADCж
        IP &= ~ADC_INT_PRI_ADDR;
        IPH &= ~ADC_INT_PRI_ADDR; //жȼ
    }
}
/************************************************
;  *    @Function Name       : ADC_Cmd
;  *    @Description         : AD ʹλ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Cmd(uint8_t newstate)
{
    if (newstate == ENABLE)
        SET_ADEN(); //ʹADCģ
    else
        CLR_ADEN(); //رADCģ
}
/************************************************
;  *    @Function Name       : ADC_IO_Configure
;  *    @Description         : AD IO
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_IO_Configure(uint16_t IOX)
{
    ADRIOS0 = REG_CLR;                         //
    ADRIOS1 &= ~(SET_BIT1 | SET_BIT0); //
    ADRIOS0 |= IOX & 0xff;                     //IO
    ADRIOS1 |= IOX >> 8;                       //IO
}
/************************************************
;  *    @Function Name       : ADC_Channel_Configure
;  *    @Description         : AD ͨ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Channel_Configure(uint8_t CH)
{
    ADCCR0 &= ~ADC_CHX_ADDR;
    ADCCR0 |= CH;
}
/************************************************
;  *    @Function Name       : ADC_Value_4H_8L
;  *    @Description         : ȡADCֵ 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
uint16_t ADC_Value_4H_8L(void)
{
    uint16_t temp = 0;
    temp = ADRH << 8;
    temp += ADRL;
    return temp;
}
/************************************************
;  *    @Function Name       : ADC_Value_8H_4L
;  *    @Description         : ȡADCֵ 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
uint16_t ADC_Value_8H_4L(void)
{
    uint16_t temp = 0;
    temp = ADRH << 4;
    temp = temp + ADRL;
    return temp;
}
/************************************************
;  *    @Function Name       : ADC_StartOneConversion
;  *    @Description         : һת 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Start_One_Conversion(void)
{
    CLR_ADEOC(); //ת
}
/************************************************
;  *    @Function Name       : ADC_GetFlagStatus
;  *    @Description         : ȡת־λ 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
flagstatus ADC_Get_FlagStatus(void)
{
    flagstatus bitstatus = RESET;
    if ((ADCCR0 & ADC_ADEOC_ADDR) != (uint8_t)RESET)
    {
        bitstatus = SET;
    }
    else
    {
        bitstatus = RESET;
    }
    return bitstatus;
}
/************************************************
;  *    @Function Name       : ADC_Zero_ADJ
;  *    @Description         : ADCУ׼
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
uint8_t ADC_Zero_ADJ(void)
{
    ADC_InitTypeDef ADC_InitStructure;
    ADC_InitStructure.ADC_clock_division = ADC_CKS_DIV_32; //16Ƶ  0.5M
    ADC_InitStructure.ADC_sam_time = ADC_SAM_TIME_15ADCLK; //15ʱ
    //ADC_InitStructure.ADC_IOx=ADC_IOP22;                //P22
    ADC_InitStructure.ADC_chx = ADC_CHGND;               //ͨGND
    ADC_InitStructure.ADC_data_sel = ADC_DATA_SEL_4H_8L; //4 8
    ADC_InitStructure.ADC_vref = ADC_VREF_VDD;           //οѹVDD
    ADC_InitStructure.ADC_interrupt = DISABLE;           //ʹж
    ADC_Init(&ADC_InitStructure);                        //ϲʼ
    ADC_Cmd(ENABLE);
    SET_OSADJEN();                                                           //ʹADCУ׼
    OSADJCR &= ~(SET_BIT3 | SET_BIT2 | SET_BIT1 | SET_BIT0); //0
    OSADJCR &= ~SET_BIT4;                                                //0000

    ADC_Start_One_Conversion(); //ת
    while (!(ADC_Get_FlagStatus()))
        ;                                    //ȴת
    if (((ADRH & 0x0F) == 0) && (ADRL == 0)) //ǷΪ0
    {
       // CLR_OSADJEN(); //رУ׼
        CLR_ADEN();    //رADC
        return PASS;   //ͨ
    }
    else
    {
        while (1)
        {
            if ((OSADJCR & 0x0f) == 0x0f)
            {
                OSADJCR &= ~(SET_BIT3 | SET_BIT2 | SET_BIT1 | SET_BIT0);
                OSADJCR |= SET_BIT4;    //1000
                ADC_Start_One_Conversion(); //ת
                while (!(ADC_Get_FlagStatus()))
                    ;                                    //ȴת
                if (((ADRH & 0x0F) == 0) && (ADRL == 0)) //ǷΪ0
                {
                  //  CLR_OSADJEN(); //رУ׼
                    CLR_ADEN();    //رADC
                    return PASS;   //ͨ
                }
                else
                {
                    while (1)
                    {
                        if ((OSADJCR & 0x0f) == 0x0f)
                        {
                          //  CLR_OSADJEN(); //رУ׼
                            CLR_ADEN();    //رADC
                            return FAIL;   //ʧ
                        }
                        else
                        {
                            OSADJCR++;                  //У׼ֵ1
                            ADC_Start_One_Conversion(); //ת
                            while (!(ADC_Get_FlagStatus()))
                                ;                                    //ȴת
                            if (((ADRH & 0x0F) == 0) && (ADRL == 0)) //ǷΪ0
                            {
                               // CLR_OSADJEN(); //رУ׼
                                CLR_ADEN();    //رADC
                                return PASS;   //ͨ
                            }
                        }
                    }
                }
            }
            else
            {
                OSADJCR++;                  //У׼ֵ1
                ADC_Start_One_Conversion(); //ת
                while (!(ADC_Get_FlagStatus()))
                    ;                                    //ȴת
                if (((ADRH & 0x0F) == 0) && (ADRL == 0)) //ǷΪ0
                {
                  //  CLR_OSADJEN(); //رУ׼
                    CLR_ADEN();    //رADC
                    return PASS;   //ͨ
                }
            }
        }
    }
}

/**************************** end of file *********************************************/
