/******************************************************************************
;  *    @MCU                 : MC51F8124
;  *    @Create Date 		 : 2021.09.01
;  *    @Author/Corporation  : SinoMCU_FAE
;  *    @΢֧QQ    : 2048615934
;  *    @΢ 		 : http://www.sinomcu.com/
;  *    @Copyright 			 : 2021 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                      
******************************************************************************/

#include "ADC.h"

/************************************************
;  *    @Function Name       : ADC_UserInit
;  *    @Description         : ûAD
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_UserInit(void)
{
    ADC_InitTypeDef ADC_InitStructure;
    ADC_InitStructure.ADC_clock_division = ADC_CKS_DIV_128;          //128Ƶ
    ADC_InitStructure.ADC_sam_time = ADC_SAM_TIME_15ADCLK; //15ʱ
    ADC_InitStructure.ADC_IOx = ADC_IOP11|ADC_IOP12|ADC_IOP13|ADC_IOP14;//P11 12 13 14
    ADC_InitStructure.ADC_chx = ADC_CH0;//ͨ0 
    ADC_InitStructure.ADC_data_sel = ADC_DATA_SEL_4H_8L;   //4 8
    ADC_InitStructure.ADC_vref = ADC_VREF_2V;              //οѹ 2V
    ADC_InitStructure.ADC_interrupt = DISABLE;             //ʹж
//    ADC_InitTypeDef.ADC_interrupt_priority=DEF_LOW;       //жȼ
    ADC_Init(&ADC_InitStructure); //ϲʼ
	ADC_Cmd(ENABLE);
}
// /************************************************
// ;  *    @Function Name       : GET_ADCValue
// ;  *    @Description         : һת
// ;  *    @IN_Parameter      	 :  ͨ
// ;  *    @Return parameter    : ADCֵ
// ;  ***********************************************/
// uint16_t GET_ADCValue(uint8_t CH)
// {
//     uint16_t temp=0;
//     ADC_ChannelConfigure(CH); //ͨ            //ͨûиıδ˴
//     CLR_ADEOC();              //ת
//     while (!(ADCCR0 & ADC_ADEOC_Addr))
//         ;                                         //ȴת
//     return ADC_Value_4H_8L();
// }
/************************************************
;  *    @Function Name       : GET_ADCValue
;  *    @Description         : һת
;  *    @IN_Parameter      	 :  ͨ
;  *    @Return parameter    : ADCֵ
;  ***********************************************/
uint16_t GET_ADCValue(void)
{
    ADC_Start_One_Conversion(); //ת
    while (!(ADC_Get_FlagStatus())); //ȴת
    return ADC_Value_4H_8L();
}
/************************************************
;  *    @Function Name       : ADC_Get_Value_Average
;  *    @Description         : ת ƽ
;  *    @IN_Parameter      	 : ͨ
;  *    @Return parameter    : ADCֵ
;  ***********************************************/
uint16_t ADC_Get_Value_Average(uint8_t CH)
{
    uint8_t channel = 0;
    uint32_t tmpBuff = 0;
    uint16_t AdcMAX = 0;
    uint16_t AdcMIN = 0xffff;
    uint16_t temp_value = 0;
    ADC_Channel_Configure(CH); //ͨ            //ͨûиıδ˴
    for (channel = 0; channel < 20; channel++)
    {
        temp_value = GET_ADCValue();
        if (channel < 2)
            continue; //ǰβ
        if (temp_value > AdcMAX)
            AdcMAX = temp_value; //
        if (temp_value < AdcMIN)
            AdcMIN = temp_value; //С
        tmpBuff += temp_value;
    }
    tmpBuff -= AdcMAX;           //ȥһ
    tmpBuff -= AdcMIN;           //ȥһС
    temp_value = (tmpBuff >> 4); //16,ȡƽֵ
    return temp_value;
}



/**************************** end of file *********************************************/