/******************************************************************************
;  *    @MCU                 : MC51F8124
;  *    @Create Date          : 2021.09.01
;  *    @Author/Corporation  : SinoMCU_FAE
;  *    @΢֧QQ    : 2048615934
;  *    @΢          : http://www.sinomcu.com/
;  *    @Copyright              : 2021 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                      
******************************************************************************/
#include "EEPROM.h"

/************************************************
;  *    @Function Name       : EEPROM_Init_Chip_Erase
;  *    @Description         : eepromȫģʽʼ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Chip_Erase()
{
    NVIC_SETPRIMASK(); //رж            //(1)
    SET_IAPEN();
    SET_IAPEN(); //ЧIAP           //(2)

    SET_ECHIPERS();
    SET_ECHIPERS(); //Чȫģʽ           //(2)
    IAPKEY = 0x5a;
    IAPKEY = 0xa5; //0x5a,0xa5
    SET_IAPSTR();  //IAPSTRλһIAP    //(3)

    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG0(); //IAPTRIG0һ           //(4)
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG1(); //IAPTRIG1һ           //(5)
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG2(); //IAPTRIG1һ           //(6)
    while (IAPCR & 0x80);                    //(7)

    NVIC_RESETPRIMASK(); //ж           //(8)
}

/************************************************
;  *    @Function Name       : EEPROM_Init_Page_Erase
;  *    @Description         : eepromҳģʽʼ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Page_Erase(uint8_t Page)
{
    uint8_t bytecnt;

    NVIC_SETPRIMASK(); //رж            //(1)
    SET_IAPEN();
    SET_IAPEN(); //FALSH IAPܣдЧ
    SET_EPAGEERS();
    SET_EPAGEERS(); //ҳģʽ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPSTR(); //IAPSTRλһIAP
    IAPADH = (Page & 0x3f) >> 4;
    IAPADL = (Page & 0x0f) << 4;
    for (bytecnt = 0; bytecnt < 16; bytecnt++)
    {
        IAPADL &= 0xf0;
        IAPADL |= bytecnt;
        IAPDB = 0;
    }
    IAPADL &= 0xf0;
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG0(); //IAPTRIG0һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG1(); //IAPTRIG1һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG2(); //IAPTRIG1һ
    while (IAPCR & 0x80);
    NVIC_RESETPRIMASK(); //ж           //(8)
}

/************************************************
;  *    @Function Name       : EEPROM_Init_Page_Write
;  *    @Description         : eepromҳд  16ֽ
;  *    @IN_Parameter        : page 0-63   W_data 
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Page_Write(uint8_t page, uint8_t *W_data)
{
    uint8_t cnt;

    NVIC_SETPRIMASK(); //رж 

    SET_IAPEN();
    SET_IAPEN(); //FALSH IAPܣдЧ
    SET_EPAGEWR();
    SET_EPAGEWR(); //ҳдģʽ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPSTR(); //IAPSTRλһ,IAP
    IAPADH = (page & 0x3f) >> 4;
    IAPADL = (page & 0x0f) << 4;
    for (cnt = 0; cnt < 16; cnt++)
    {
        IAPADL &= 0xf0;
        IAPADL |= cnt;
        IAPDB = W_data[cnt];
    }
    IAPADL &= 0xf0;
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG0(); //IAPTRIG0һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG1(); //IAPTRIG1һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG2(); //IAPTRIG1һ
    while (IAPCR & 0x80); //IAPSTR
    NVIC_RESETPRIMASK(); //ж 
}
/************************************************
;  *    @Function Name       : EEPROM_Byte_Erase
;  *    @Description         : eepromֲģʽʼ
;  *    @IN_Parameter      	 :addar 0-0x3ff W_data 
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Byte_Erase(uint16_t addar)
{
    NVIC_SETPRIMASK(); //رж 
    SET_IAPEN();
    SET_IAPEN(); //FALSH IAPܣдЧ
    SET_EPAGEERS();
    SET_EPAGEERS(); //ҳģʽ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPSTR(); //IAPSTRλһIAP
    IAPADH = (addar >> 8) & 0xff;
    IAPADL = addar & 0xff;
    IAPDB = 0;
    IAPADL &= 0xf0;
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG0(); //IAPTRIG0һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG1(); //IAPTRIG1һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG2(); //IAPTRIG1һ
    while (IAPCR & 0x80);
    NVIC_RESETPRIMASK(); //ж 
}
/************************************************
;  *    @Function Name       : EEPROM_Init_Byte_Write
;  *    @Description         : eepromֽд
;  *    @IN_Parameter        : addar 0-0x3ff W_data 
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Byte_Write(uint16_t addar, uint8_t W_data)
{
    NVIC_SETPRIMASK(); //رж 
    SET_IAPEN();
    SET_IAPEN(); //FALSH IAPܣдЧ
    SET_EPAGEWR();
    SET_EPAGEWR(); //ҳдģʽ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPSTR(); //IAPSTRλһIAP
    IAPADH = (addar >> 8) & 0xff;
    IAPADL = addar & 0xff;
    IAPDB = W_data; //W_data
    IAPADL &= 0xf0;
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG0(); //IAPTRIG0һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG1(); //IAPTRIG1һ
    IAPKEY = 0x5a;
    IAPKEY = 0xa5;
    SET_IAPTRIG2(); //IAPTRIG1һ
    while (IAPCR & 0x80);
    NVIC_RESETPRIMASK(); //ж 
}
/************************************************
;  *    @Function Name       : EEPROM_Byte_Read
;  *    @Description         : eepromֽڶ
;  *    @IN_Parameter        : addar 0-0x3ff
;  *    @Return parameter    : 
;  ***********************************************/
uint8_t EEPROM_Byte_Read(uint16_t addr)
{
    uint8_t R_data;
    NVIC_SETPRIMASK(); //رж 
    SET_EERD(); //EERD1
    R_data = *(uint8_t __IO code *)addr;
	CLR_EERD(); //EERD0
    NVIC_RESETPRIMASK(); //ж 
    return R_data;
}
/************************************************
;  *    @Function Name       : EEPROM_Read
;  *    @Description         : EEPROMճȶȡ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Read(uint16_t addr, uint8_t idata *R_data, uint16_t len)
{
    uint16_t cnt;
    NVIC_SETPRIMASK(); //رж 
    SET_EERD(); //EERD1
    for (cnt = 0; cnt < len; cnt++)
    {
        R_data[cnt] = *(uint8_t __IO code *)addr;
        addr++;
    }
	CLR_EERD(); //EERD0
    NVIC_RESETPRIMASK(); //ж 
}
/**************************** end of file *********************************************/







