/******************************************************************************
;  *    @MCU                 : MC51F8124
;  *    @Create Date 		 : 2021.09.01
;  *    @Author/Corporation  : SinoMCU_FAE
;  *    @΢֧QQ    : 2048615934
;  *    @΢ 		 : http://www.sinomcu.com/
;  *    @Copyright 			 : 2021 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                      
******************************************************************************/
#include "TIMER.h"

/************************************************
;  *    @Function Name       : Timer0_Init
;  *    @Description         : T0
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void Timer0_Init(void)
{
#if (TIMER_MODE == 0) //T0ʽ0  13λʱ/ʱ
	TMOD = 0x00;	  //ڲʱ  ʽ0
	TCON = 0x00;
	TCON1 = 0x03; //FT0=FSYS/16	ֹIOת
	TR0 = 0;	  //Ƕд TLx/THx ֵֹͣ(TR0=0;)
	TL0 = 0x18;   //5λ  8λ	1ms 8192-1000=7192 /1 1100 000/1 1000
	TH0 = 0xE0;   //дʱȶдLH

	IP = 0x02;	
	IPH = 0x00;   //жϵȼ1()
	T0IE = 1;		
	EA = 1;		  //жʹλ
	TR0 = 1;	  //T0
#endif
#if (TIMER_MODE == 1) //T0ʽ1  16λʱ/ʱ
	TMOD = 0x01;	  //ڲʱ  ʽ1
	TCON = 0x00;
	TCON1 = 0x03; //FT0=FSYS/16	ֹIOת
	TR0 = 0;	  //Ƕд TLx/THx ֵֹͣ(TR0=0;)
	TL0 = 0x18;   //	1ms
	TH0 = 0xFC;   //дʱȶдLH

	IP = 0x02;
	IPH = 0x00; //жϵȼ1()
	T0IE = 1;
	EA = 1;
	TR0 = 1;
#endif
#if (TIMER_MODE == 2) //T0ʽ2  8λؼʱ/ʱ
	TMOD = 0x02;	  //ڲʱ  ʽ2
	TCON = 0x00;
	TCON1 = 0x03;	//FT0=FSYS/16	ֹIOת
	TR0 = 0;		 //Ƕд TLx/THx ֵֹͣ(TR0=0;)
	TL0 = 256 - 200; //	 200us
	TH0 = 256 - 200;

	IP = 0x02;
	IPH = 0x00; //жϵȼ1()
	T0IE = 1;
	EA = 1;
	TR0 = 1;
#endif
#if (TIMER_MODE == 3)	//T0ʽ3	8λ/ʱ(ֻT0)
	TMOD = 0x03;	  //ڲʱ  ʽ3
	TCON = 0x00;
	TCON1 = 0x33;	//FT0/1=FSYS/16	ֹIOת
	TR0 = 0;		 //Ƕд TLx/THx ֵֹͣ(TRx=0;)
	TR1 = 0;	
	TL0 = 256 - 200; 	//	 200us
	TH0 = 256 - 100;	//	 100us

	IP = 0x02;
	IPH = 0x00; //T0жϵȼ1()  TLжϵȼ0()

	T0IE = 1;
	T1IE = 1;
	EA = 1;
	TR0 = 1;
	TR1 = 1;
#endif
}

void Timer0_ISR(void) interrupt T0_IRQn
{
	SFR_INTERRUPT_BUFF_BIT_T0 = SFRSL0;		//жϻSFR
				//л0ҳĴ	
#if (TIMER_MODE == 0)
	SFRSL0=0;	
	TR0 = 0;	//Ƕд TLx/THx ֵֹͣ(TR0=0;)
	TL0 = 0x18; //5λ   8λ
	TH0 = 0xE0; //дʱȶдLH
	P05D = !P05D;
	TR0 = 1;
#endif
#if (TIMER_MODE == 1)
	SFRSL0=0;	
	TR0 = 0; //Ƕд TLx/THx ֵֹͣ(TR0=0;)
	TL0 = 0x18;
	TH0 = 0xFC; //дʱȶдLH
	P05D = !P05D;
	TR0 = 1;
#endif
#if (TIMER_MODE == 2)
	SFRSL0=0;	
	P05D = !P05D;
#endif
#if (TIMER_MODE == 3)
	SFRSL0=0;	
	TR0 = 0;		 //Ƕд TLx/THx ֵֹͣ(TRx=0;)	
	TL0 = 256 - 200; 	//	 200us
	P05D = !P05D;
	TR0 = 1;
#endif
	SFRSL0 = SFR_INTERRUPT_BUFF_BIT_T0;		//˳жϻԭSFR
}

void Timer1_ISR(void) interrupt T1_IRQn
{
	SFR_INTERRUPT_BUFF_BIT_T1 = SFRSL0;		//жϻSFR
#if (TIMER_MODE == 3)	
	SFRSL0=0;		
	TR1 = 0;			//Ƕд TLx/THx ֵֹͣ(TRx=0;)
	TH0 = 256 - 100;	//	 100us
	P04D = !P04D;
	TR1 = 1;
#endif
	SFRSL0 = SFR_INTERRUPT_BUFF_BIT_T1;		//˳жϻԭSFR
}

/**************************** end of file *********************************************/







