/******************************************************************************
;  *    @MCU                 : MC51F8124
;  *    @Create Date 		 : 2021.09.01
;  *    @Author/Corporation  : SinoMCU_FAE
;  *    @΢֧QQ    : 2048615934
;  *    @΢ 		 : http://www.sinomcu.com/
;  *    @Copyright 			 : 2021 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                      
******************************************************************************/
#include "UART.h"

/************************************************
;  *    @Function Name       : UART0_Init
;  *    @Description         : 0ʼ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void UART0_Init(void)
{
	
	PCON |= SET_BIT4; //ʹUART0
	SCON &= 0x3f;
	SCON |= 0x50; //ʽ1  

	TMOD &= 0xCF;
	TMOD |= SET_BIT5; //ڲʱ  ʽ2
	TL1 = T1_Cnt;
	TH1 = T1_Cnt;
	TR1 = 1; //T1

	IE |= SET_BIT4; //UART0ж
}
/************************************************
;  *    @Function Name       : putchar   (ռ1kROM)
;  *    @Description         : printfضputchar
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
char putchar(char tx_data)
{
	SBUF = tx_data; //дݵUARTݼĴ
	while (!(SCON & 0x02)); //ȴǰݷ
	SCON &= ~SET_BIT1;
	return tx_data;
}


void UART0_ISR(void) interrupt UART0_IRQn
{
	SFR_INTERRUPT_BUFF_BIT_UART0 = SFRSL0;		//жϻSFR
	SFRSL0=0;				//л0ҳĴ
	if (((SCON & SET_BIT0) == SET_BIT0))
	{
		SCON &= ~SET_BIT0;
		if (UART_RX_END == 0)
		{
			if (UART_RX_STA == 0)
			{
				if (SBUF == 0x0d)		//յ0x0d
				{
					UART_RX_STA = 1;
				}
				else
				{
					UART_rx_buff[UART_rx_len] = SBUF;
					UART_rx_len++;
				}
			}
			else
			{
				if (SBUF == 0x0a)		//յ0x0a
				{
					UART_RX_END = 1;
				}
				else
				{
					UART_rx_len = 0;
					UART_RX_STA = 0;
				}
			}
		}
	}
	//	if (((SCON_1 & 0x02) == 0x02))
	//	{
	//		//SCON_1 &= ~SET_BIT1;
	//	}
	SFRSL0 = SFR_INTERRUPT_BUFF_BIT_UART0;		//˳жϻԭSFR
}


/**************************** end of file *********************************************/


