/******************************************************************************
;  *    @MCU                 : MC51F8124
;  *    @Create Date 		 : 2021.09.01
;  *    @Author/Corporation  : SinoMCU_FAE
;  *    @΢֧QQ    : 2048615934
;  *    @΢ 		 : http://www.sinomcu.com/
;  *    @Copyright 			 : 2021 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                      
******************************************************************************/

#include "User_Def.h"

void GPIO_Init(void);

//------------------- Define Port as Input Hi-Z mode ----------------
	
#define P00_INPUTHIZ_MODE				P0MOD0&=~SET_BIT0;P0MOD0&=~SET_BIT1
#define P01_INPUTHIZ_MODE				P0MOD0&=~SET_BIT2;P0MOD0&=~SET_BIT3
#define P02_INPUTHIZ_MODE				P0MOD0&=~SET_BIT4;P0MOD0&=~SET_BIT5
#define P03_INPUTHIZ_MODE				P0MOD0&=~SET_BIT6;P0MOD0&=~SET_BIT7
#define P04_INPUTHIZ_MODE				P0MOD1&=~SET_BIT0;P0MOD1&=~SET_BIT1
#define P05_INPUTHIZ_MODE				P0MOD1&=~SET_BIT2;P0MOD1&=~SET_BIT3
#define P06_INPUTHIZ_MODE				P0MOD1&=~SET_BIT4;P0MOD1&=~SET_BIT5
#define P07_INPUTHIZ_MODE				P0MOD1&=~SET_BIT6;P0MOD1&=~SET_BIT7
	
#define P10_INPUTHIZ_MODE				P1MOD0&=~SET_BIT0;P1MOD0&=~SET_BIT1
#define P11_INPUTHIZ_MODE				P1MOD0&=~SET_BIT2;P1MOD0&=~SET_BIT3
#define P12_INPUTHIZ_MODE				P1MOD0&=~SET_BIT4;P1MOD0&=~SET_BIT5
#define P13_INPUTHIZ_MODE				P1MOD0&=~SET_BIT6;P1MOD0&=~SET_BIT7
#define P14_INPUTHIZ_MODE				P1MOD1&=~SET_BIT0;P1MOD1&=~SET_BIT1
#define P15_INPUTHIZ_MODE				P1MOD1&=~SET_BIT2;P1MOD1&=~SET_BIT3
#define P16_INPUTHIZ_MODE				P1MOD1&=~SET_BIT4;P1MOD1&=~SET_BIT5
#define P17_INPUTHIZ_MODE				P1MOD1&=~SET_BIT6;P1MOD1&=~SET_BIT7

#define P20_INPUTHIZ_MODE				P2MOD0&=~SET_BIT0;P2MOD0&=~SET_BIT1
#define P21_INPUTHIZ_MODE				P2MOD0&=~SET_BIT2;P2MOD0&=~SET_BIT3
#define P22_INPUTHIZ_MODE				P2MOD0&=~SET_BIT4;P2MOD0&=~SET_BIT5
#define P23_INPUTHIZ_MODE				P2MOD0&=~SET_BIT6;P2MOD0&=~SET_BIT7
#define P24_INPUTHIZ_MODE				P2MOD1&=~SET_BIT0;P2MOD1&=~SET_BIT1
#define P25_INPUTHIZ_MODE				P2MOD1&=~SET_BIT2;P2MOD1&=~SET_BIT3
#define P26_INPUTHIZ_MODE				P2MOD1&=~SET_BIT4;P2MOD1&=~SET_BIT5
#define P27_INPUTHIZ_MODE				P2MOD1&=~SET_BIT6;P2MOD1&=~SET_BIT7

#define P30_INPUTHIZ_MODE				P3MOD0&=~SET_BIT0;P3MOD0&=~SET_BIT1
#define P31_INPUTHIZ_MODE				P3MOD0&=~SET_BIT2;P3MOD0&=~SET_BIT3
    
#define SET_ALL_GPIO_INPUTHIZ_MODE		P0MOD0=0x00;P0MOD1=0x00;P1MOD0=0x00;P1MOD1=0x00;P2MOD0=0x00;P2MOD1=0x00;P3MOD0=0x00

//------------------- Define Port as Push Pull mode -----------------

#define P00_PUSHPULL_MODE				P0MOD0&=~SET_BIT1;P0MOD0|=SET_BIT0
#define P01_PUSHPULL_MODE				P0MOD0&=~SET_BIT3;P0MOD0|=SET_BIT2
#define P02_PUSHPULL_MODE				P0MOD0&=~SET_BIT5;P0MOD0|=SET_BIT4
#define P03_PUSHPULL_MODE				P0MOD0&=~SET_BIT7;P0MOD0|=SET_BIT6
#define P04_PUSHPULL_MODE				P0MOD1&=~SET_BIT1;P0MOD1|=SET_BIT0
#define P05_PUSHPULL_MODE				P0MOD1&=~SET_BIT3;P0MOD1|=SET_BIT2
#define P06_PUSHPULL_MODE				P0MOD1&=~SET_BIT5;P0MOD1|=SET_BIT4
#define P07_PUSHPULL_MODE				P0MOD1&=~SET_BIT7;P0MOD1|=SET_BIT6

#define P10_PUSHPULL_MODE				P1MOD0&=~SET_BIT1;P1MOD0|=SET_BIT0
#define P11_PUSHPULL_MODE				P1MOD0&=~SET_BIT3;P1MOD0|=SET_BIT2
#define P12_PUSHPULL_MODE				P1MOD0&=~SET_BIT5;P1MOD0|=SET_BIT4
#define P13_PUSHPULL_MODE				P1MOD0&=~SET_BIT7;P1MOD0|=SET_BIT6
#define P14_PUSHPULL_MODE				P1MOD1&=~SET_BIT1;P1MOD1|=SET_BIT0
#define P15_PUSHPULL_MODE				P1MOD1&=~SET_BIT3;P1MOD1|=SET_BIT2
#define P16_PUSHPULL_MODE				P1MOD1&=~SET_BIT5;P1MOD1|=SET_BIT4
#define P17_PUSHPULL_MODE				P1MOD1&=~SET_BIT7;P1MOD1|=SET_BIT6

#define P20_PUSHPULL_MODE				P2MOD0&=~SET_BIT1;P2MOD0|=SET_BIT0
#define P21_PUSHPULL_MODE				P2MOD0&=~SET_BIT3;P2MOD0|=SET_BIT2
#define P22_PUSHPULL_MODE				P2MOD0&=~SET_BIT5;P2MOD0|=SET_BIT4
#define P23_PUSHPULL_MODE				P2MOD0&=~SET_BIT7;P2MOD0|=SET_BIT6
#define P24_PUSHPULL_MODE				P2MOD1&=~SET_BIT1;P2MOD1|=SET_BIT0
#define P25_PUSHPULL_MODE				P2MOD1&=~SET_BIT3;P2MOD1|=SET_BIT2
#define P26_PUSHPULL_MODE				P2MOD1&=~SET_BIT5;P2MOD1|=SET_BIT4
#define P27_PUSHPULL_MODE				P2MOD1&=~SET_BIT7;P2MOD1|=SET_BIT6

#define P30_PUSHPULL_MODE				P3MOD0&=~SET_BIT1;P3MOD0|=SET_BIT0 
#define P31_PUSHPULL_MODE				P3MOD0&=~SET_BIT3;P3MOD0|=SET_BIT2 

#define SET_ALL_GPIO_PUSHPULL_MODE		P0MOD0=0x55;P0MOD1=0x55;P1MOD0=0x55;P1MOD1=0x55;P2MOD0=0x55;P2MOD1=0x55;P3MOD0=0x05

//------------------- Define Port as Input with Pullup Z ------------

#define P00_INPUT_PULLUPZ				P0PU|=SET_BIT0
#define P01_INPUT_PULLUPZ				P0PU|=SET_BIT1
#define P02_INPUT_PULLUPZ				P0PU|=SET_BIT2
#define P03_INPUT_PULLUPZ				P0PU|=SET_BIT3
#define P04_INPUT_PULLUPZ				P0PU|=SET_BIT4
#define P05_INPUT_PULLUPZ				P0PU|=SET_BIT5
#define P06_INPUT_PULLUPZ				P0PU|=SET_BIT6
#define P07_INPUT_PULLUPZ				P0PU|=SET_BIT7

#define P10_INPUT_PULLUPZ				P1PU|=SET_BIT0
#define P11_INPUT_PULLUPZ				P1PU|=SET_BIT1
#define P12_INPUT_PULLUPZ				P1PU|=SET_BIT2
#define P13_INPUT_PULLUPZ				P1PU|=SET_BIT3
#define P14_INPUT_PULLUPZ				P1PU|=SET_BIT4
#define P15_INPUT_PULLUPZ				P1PU|=SET_BIT5
#define P16_INPUT_PULLUPZ				P1PU|=SET_BIT6
#define P17_INPUT_PULLUPZ				P1PU|=SET_BIT7

#define P20_INPUT_PULLUPZ				P2PU|=SET_BIT0
#define P21_INPUT_PULLUPZ				P2PU|=SET_BIT1
#define P22_INPUT_PULLUPZ				P2PU|=SET_BIT2
#define P23_INPUT_PULLUPZ				P2PU|=SET_BIT3
#define P24_INPUT_PULLUPZ				P2PU|=SET_BIT4
#define P25_INPUT_PULLUPZ				P2PU|=SET_BIT5
#define P26_INPUT_PULLUPZ				P2PU|=SET_BIT6
#define P27_INPUT_PULLUPZ				P2PU|=SET_BIT7

#define P30_INPUT_PULLUPZ				P3PU|=SET_BIT0
#define P31_INPUT_PULLUPZ				P3PU|=SET_BIT1

#define SET_ALL_GPIO_INPUT_PULLUPZ		P0PU=0xff;P1PU=0xff;P2PU=0xff;P3PU=0xf3
#define CLR_ALL_GPIO_INPUT_PULLUPZ		P0PU=0x0;P1PU=0x0;P2PU=0x0;P3PU=0x0

//------------------- Define Individual Pin HI for Each Port -----------

#define P00_HI							P00D=HI
#define P01_HI							P01D=HI
#define P02_HI							P02D=HI
#define P03_HI							P03D=HI
#define P04_HI							P04D=HI
#define P05_HI							P05D=HI
#define P06_HI							P06D=HI
#define P07_HI							P07D=HI

#define P10_HI							P10D=HI
#define P11_HI							P11D=HI
#define P12_HI							P12D=HI
#define P13_HI							P13D=HI
#define P14_HI							P14D=HI
#define P15_HI							P15D=HI
#define P16_HI							P16D=HI
#define P17_HI							P17D=HI

#define P20_HI							P20D=HI
#define P21_HI							P21D=HI
#define P22_HI							P22D=HI
#define P23_HI							P23D=HI
#define P24_HI							P24D=HI
#define P25_HI							P25D=HI
#define P26_HI							P26D=HI
#define P27_HI							P27D=HI

#define P30_HI							P30D=HI  
#define P31_HI							P31D=HI  

#define P0_ALL_HI						P0=0xff
#define P1_ALL_HI						P1=0xff
#define P2_ALL_HI						P2=0xff
#define P3_ALL_HI						P3=0x03

//------------------- Define Individual Pin LOW for Each Port -----------

#define P00_LOW							P00D=LOW
#define P01_LOW							P01D=LOW
#define P02_LOW							P02D=LOW
#define P03_LOW							P03D=LOW
#define P04_LOW							P04D=LOW
#define P05_LOW							P05D=LOW
#define P06_LOW							P06D=LOW
#define P07_LOW							P07D=LOW


#define P10_LOW							P10D=LOW
#define P11_LOW							P11D=LOW
#define P12_LOW							P12D=LOW
#define P13_LOW							P13D=LOW
#define P14_LOW							P14D=LOW
#define P15_LOW							P15D=LOW
#define P16_LOW							P16D=LOW
#define P17_LOW							P17D=LOW

#define P20_LOW							P20D=LOW
#define P21_LOW							P21D=LOW
#define P22_LOW							P22D=LOW
#define P23_LOW							P23D=LOW
#define P24_LOW							P24D=LOW
#define P25_LOW							P25D=LOW
#define P26_LOW							P26D=LOW
#define P27_LOW							P27D=LOW

#define P30_LOW							P30D=LOW
#define P31_LOW							P31D=LOW

#define P0_ALL_LOW						P0=0x00
#define P1_ALL_LOW						P1=0x00
#define P2_ALL_LOW						P2=0x00
#define P3_ALL_LOW						P3=0x00

/**************************** end of file *********************************************/